<?php
	// causing orders to sync 3 or 4 times
	return ;

    /**
     * This file contains functions for registering crons for syncing unsynced orders.
     * This script uses sales order plugin
     */

    // ADD CRON SCHEDULE FOR 5 minutes, WP doesn't provide it by default
    add_filter('cron_schedules', 'addCronType');

    function addCronType($schedules) {

        $schedules['5minute'] = [
            'interval' => 300,
            'display' => __('Once every 5 minutes'),
        ];


        return $schedules;
    }

    //register cron function for syncing unsyced order
    add_action('init', "regsiterCron");

    function regsiterCron() {
        if (!wp_next_scheduled('cron_process_unsynced_orders')) {
            //set default emails
            wp_schedule_event(time(), '5minute', 'cron_process_unsynced_orders');
        }
    }

    //CRON FUNCTION to sync unsynced orders
    add_action("cron_process_unsynced_orders", "processUnsyncedOrders");

    function processUnsyncedOrders() {
		delete_option( 'sync_ids');
        //get unsycned orders
        $unsynced_orders = getUnsyncedOrders();
        if ($unsynced_orders->have_posts()) {
			
			//add order ids to array on options table
			//$orderids = array();
			$orderids = get_option( 'sync_ids', $default = false );
			//update_option( 'sync_ids_test', $orderids );
			foreach ($unsynced_orders->posts as $order_id) {
				
				$orderids[] = $order_id;
				
			}
			update_option( 'sync_ids', $orderids );
			
			//Get array of order ids
			$checkids = get_option( 'sync_ids', $default = false );
			//remove duplicates
			$processids = array_unique($checkids);
			
			//Process orders with duplicates removed

            if (!class_exists('In8_Customers_Sales_Sync')) {
                $sales_order_sync_file = WP_PLUGIN_DIR . '/in8sync-salesorder/inc/sync.php';
                if (file_exists($sales_order_sync_file)) {
                    require_once($sales_order_sync_file);
                }
            }
            if (!class_exists('In8_Customers_Sales_Sync')) {
                return;
            }
            
			foreach ($processids as $order_id) {

				//initiate sync
				$In8_Customers_Sales_Sync = new In8_Customers_Sales_Sync();
				
                //reset customer
                //$In8_Customers_Sales_Sync->customer_internal_id = 0;
                //Skip order if it has once failed to sync to NS, these orders will need to sync manually by admin
                if (orderFailedPreviously($order_id)) {
                    //continue;
                }
                $In8_Customers_Sales_Sync->newOrderCreated($order_id);
                $order_co_options = In8_SalesOrder::getOptions(2);
                if (!isset($order_co_options['sync_on_creation'])) {
                    $In8_Customers_Sales_Sync->sendOrderToNetsuite($order_id, 0, TRUE);
                }
            }
        }
    }

    //check is order has failed to sync to NS
    function orderFailedPreviously($id) {
        global $wpdb;
        $rowcount = $wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . "in8sync_log WHERE woo_object_id = $id AND `operation` = 'salesorder'");

        if ($rowcount > 0) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    //function for unsynced orders
    function getUnsyncedOrders() {
        //this query will pull order processing status orders for which meta key internalid is empty
        $args = array(
            'meta_key' => 'internalid',
            'posts_per_page' => -1,
            'meta_compare' => "NOT EXISTS",
            'post_type' => 'shop_order',
            'post_status' => 'wc-processing',
            'fields' => 'ids',
            'date_query' => array(
                array(
                    'after' => '1 days ago'
                )
          )
        );

        return new WP_Query($args);
    }
    