<?php
	// causing orders to sync 3 or 4 times
	return ;
	
    class IN8UnsynchedOrders {

        private static $instance = NULL;
        private static $email_settings = [];
        private $default_emails = ""; //COMMAS SEPARATED LIST 
//      private $default_emails = "manish@ineight.net"; //COMMAS SEPARATED LIST
        private $default_frequency = "daily";

        static public function getInstance($email_settings = []) {
            if (empty($email_settings)) {
                return;
            }
            if (self::$instance === NULL) {
                self::$email_settings = $email_settings;
                self::$instance = new IN8UnsynchedOrders();
            }
            return self::$instance;
        }

        function __construct() {
            //register cron function for sending emails to customers
            add_action('init', [$this, "regsiterCron"]);
            //regsiter cron action
            add_action('cron_reprocess_failed_orders', [$this, 'notifyUnsyncedOrders']);
            //display a list of failed orders using ADMIN URL  -> admin.php?get_failed_order_list=1
            add_action('admin_init', [$this, 'fetchFailedOrders']);
        }

        function regsiterCron() {

            if (!wp_next_scheduled('cron_reprocess_failed_orders')) {

                if (!isset(self::$email_settings['unsynced_orders_email_frequency'])) {
                    self::$email_settings['unsynced_orders_email_frequency'] = $this->default_frequency;
                }
                //set default emails
                wp_schedule_event(time(), self::$email_settings['unsynced_orders_email_frequency'], 'cron_reprocess_failed_orders');
            }
        }

        function notifyUnsyncedOrders() {
            if (!isset(self::$email_settings['unsynced_order_emails']) && !empty($this->default_emails)) {
                self::$email_settings['unsynced_order_emails'] = $this->default_emails;
            }

            if (empty(self::$email_settings['unsynced_order_emails'])) {
                return;
            }

            $failed_orders = $this->getFailedOrders();
            if ($failed_orders->have_posts()) {
                $failed_order_ids = json_encode($failed_orders->posts);
                $failed_order_ids = "Unsynced orders <br> " . $failed_order_ids;
                $message_subject = "IN8 : Unsynced order list for " . get_site_url();
                $emails = explode(",", self::$email_settings['unsynced_order_emails']);
                if (!empty($emails)) {
                    foreach ($emails as $email) {
                        $email = trim($email);
                        wp_mail($email, $message_subject, $failed_order_ids);
                    }
                }
            }
        }

        function fetchFailedOrders() {
            if (empty($_GET['get_failed_order_list'])) {
                return;
            }
            $failed_orders = $this->getFailedOrders();
            if ($failed_orders->have_posts()) {
                foreach ($failed_orders->posts as $order_id) {
                    echo $order_id . "<br>";
                }
            }
        }

        //function for fetching failed orders
        function getFailedOrders() {
            //this query will pull order processing status orders for which meta key internalid is empty
            $args = array(
                'meta_key' => 'internalid',
                'posts_per_page' => -1,
                'meta_compare' => "NOT EXISTS",
                'post_type' => 'shop_order',
                'post_status' => 'wc-processing',
                'fields' => 'ids',
                'date_query' => array(
                    array(
                        'after' => '50 days ago'
                    )
                )
            );

            return new WP_Query($args);
        }

    }

    $email_settings = IN8_Settings::getTabSettings("in8_tab_email",'unsynced_orders');

    IN8UnsynchedOrders::getInstance($email_settings);
    