<?php

    add_filter("in8_admin_tab", "adjustTabSortOrder", 100);

    function adjustTabSortOrder($tabs) {
        uasort($tabs, 'sortTabOrder');
        return $tabs;
    }

    function sortTabOrder($a, $b) {
        return $a['priority'] - $b['priority'];
    }

    add_action('admin_init', 'importOldSettings');

    function importOldSettings() {
        $old = "in8_netsuite_general";
        $old_option = get_option($old);
        if ($old_option !== FALSE) {
            if ($old == 'in8_netsuite_general') {
                $new = "in8_tab_general";
                $new_option = get_option($new);

                if (!empty($old_option['in8_netsuite_restlets'])) {
                    if (isset($new_option['ns_api_creds'])) {
                        unset($new_option['ns_api_creds']);
                    }
                    $new_option['ns_api_creds'] = $old_option['in8_netsuite_restlets'];
                }

                if (!empty($old_option['in8_api_keys'])) {
                    if (isset($new_option['in8_api_keys'])) {

                        unset($new_option['in8_api_keys']);
                    }
                    $new_option['in8_api_keys']['api_key'] = $old_option['in8_api_keys']['in8_api_key'];
                    $new_option['in8_api_keys']['api_secret'] = $old_option['in8_api_keys']['in8_api_secret'];
                }
                if (!empty($old_option['in8_debug_options'])) {
                    if (isset($new_option['debug'])) {
                        unset($new_option['debug']);
                    }
                    $new_option['debug']['debug_level'] = $old_option['in8_debug_options']['debug_level'];
                }

                update_option($new, $new_option);

                if (!empty($old_option['in8_netsuite_inventory'])) {
                    //inventory
                    update_option("in8_netsuite_inventory", $old_option['in8_netsuite_inventory']);
                }

                if (!empty($old_option['in8_debug_emails'])) {
                    $old_email_options = get_option('in8_debug_emails');
                    if ($old_email_options) {
                        $old_email_options['debug_emails']['default_debug_emails'] = $old_option['in8_debug_emails']['in8_debug_emails'];
                        //inventory
                        update_option("in8_tab_email", $old_email_options);
                    }
                }

                delete_option($old);
            }
        }
    }
	
	// enable the modal for logs
	if( function_exists('add_thickbox') ) {
		add_action('admin_enqueue_scripts', function(){
			add_thickbox();
		});
	}
 