<?php

    class In8_Logs_Tab {

        public function __construct() {
            //ajax for saving plugin admin settings
            add_action('wp_ajax_load_in8_logs', array($this, 'getLogs'));
            add_action('wp_ajax_get_server_time', array($this, 'getServerTime'));
        }

        public function getServerTime() {
            echo date('Y-m-d h:i');
            die;
        }

        public function getLogs() {
            global $wpdb;


            require_once IN8_MAIN_DIR . '/code/libraries/datatables.php';
	        $processed_rows = [];
            $request = $_POST;
            $binding = array();
            if (!empty($request)) {

                $datatables = new Datatables();

                $columns = array(
                    array('db' => 'log.id as id',
                        'dt' => 0,
                        'db_ref' => 'id'
                    ),
                    array(
                        'db' => 'log.created_at as created_at',
                        'dt' => 1,
                        'db_ref' => 'created_at'
                    ),
                    array(
                        'db' => 'log.operation as operation',
                        'dt' => 2,
                        'db_ref' => 'operation'
                    ),
                    array(
                        'db' => 'log.notes as notes',
                        'dt' => 3,
                        'db_ref' => 'notes'
                    ),
                    array(
                        'db' => 'log.woo_object_id as woo_object_id',
                        'dt' => 4,
                        'db_ref' => 'woo_object_id'
                    )
                );




                $limit = $datatables->limit($request, $columns);
                $order = $datatables->order($request, $columns);
                $where = $datatables->filter($request, $columns, $binding);

                $query = "SELECT SQL_CALC_FOUND_ROWS " . implode(",", $datatables->pluck($columns, 'db')) . " FROM {$wpdb->prefix}in8sync_log as log 
                         $where
			 $order
			 $limit";

                // Main query to actually get the data
                $data = $wpdb->get_results($query);

                //filtering data
                $data_filter = $wpdb->get_results("SELECT FOUND_ROWS() as filtered_rows");
                //total filtered records
                $recordsFiltered = $data_filter[0]->filtered_rows;

                $recordsTotal = $recordsFiltered;

                //array to be returned
                $unprocessed_rows = array();
                if ($recordsTotal > 0) {
                    $unprocessed_rows = $datatables->data_output($columns, (array) $data);
                }

                if (!empty($unprocessed_rows)) {
                    $processed_rows = [];

                    foreach ($unprocessed_rows as $key => $unprocessed_row) {
                        $processed_rows[$key] = $unprocessed_row;
                        $object = $unprocessed_row[2];
                        $object_id = $unprocessed_row[4];

                        if ($unprocessed_row[3] != 'success') {
                            $log_file_url = IN8_Settings::getLogFileURL('log', $object, $object_id);
                            if ($log_file_url !== FALSE) {
                                $processed_rows[$key][] = "<a href='?download_in8_log_type=log&download_in8_log_object=" . $object . "&download_in8_log_object_id=" . $object_id . "'>Download log file</a>";
                            } else {
                                $processed_rows[$key][] = "No file exists";
                            }
                        } else {
                            $processed_rows[$key][] = "No file exists";
                        }

                        $requestdata_file_url = IN8_Settings::getLogFileURL('requestdata', $object, $object_id);
                        if ($requestdata_file_url !== FALSE) {
                            $processed_rows[$key][] = "<a href='?download_in8_log_type=requestdata&download_in8_log_object=" . $object . "&download_in8_log_object_id=" . $object_id . "'>Download log file</a>";
                        } else {
                            $processed_rows[$key][] = "No file exists";
                        }
                    }
                }

                //json to be returned
                echo json_encode(array(
                    "draw" => intval($request['draw']),
                    "recordsTotal" => intval($recordsTotal),
                    "recordsFiltered" => intval($recordsFiltered),
                    "data" => $processed_rows
                ));
                die;
            }
            die;
        }

    }

    new In8_Logs_Tab();
    