<?php

    add_action('wp_loaded', 'setupCrons');
    //SETUP CRONS ON WP LOAD
    function setupCrons() {
        //WP CRON for deleting older logs
        if (!wp_next_scheduled('deleteOldLogs')) {
            wp_schedule_event(time(), 'daily', 'deleteOldLogs');
        }
    }
    
    add_action('deleteOldLogs', 'deleteOlderLogs');
    //deletes log files and db entires
    function deleteOlderLogs() {
        global $wpdb;
        $sql = $wpdb->prepare("DELETE FROM {$wpdb->prefix}in8sync_log WHERE created_at < (NOW() - INTERVAL 7 DAY)", '');
        $wpdb->query($sql); //execute query
        foreach (IN8_Settings::$log_dirs as $object => $plugin_name) {
            //delete old logs files
            IN8_Settings::deleteLogFiles('log', $object);
            //delete json files
            IN8_Settings::deleteLogFiles('requestdata', $object);
        }
    }

    function download_IN8_file() {

        $log_file_url = IN8_Settings::getLogFilePath($_GET['download_in8_log_type'], $_GET['download_in8_log_object'], $_GET['download_in8_log_object_id']);

        if (file_exists($log_file_url)) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Content-Disposition: attachment; filename="' . basename($log_file_url) . '"');
            header('Expires: 0');
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Length: ' . filesize($log_file_url));
            readfile($log_file_url);
        }
        exit;
    }

    if (!empty($_GET['download_in8_log_type']) && !empty($_GET['download_in8_log_object']) && !empty($_GET['download_in8_log_object_id'])) {
        download_IN8_file();
    }
	
	
    // View Log file content[Modal]
	add_action('admin_enqueue_scripts', function (){
		wp_enqueue_style('in8_log_modal', IN8_MAIN_URL.'assets/css/logModal.css');
	});
	function view_IN8_file()
	{
		
		$log_file_url = IN8_Settings::getLogFilePath($_GET['view_in8_log_type'], $_GET['view_in8_log_object'], $_GET['view_in8_log_object_id']);
		
		global $wpdb;
		$results = $wpdb->get_results("SELECT * FROM {$wpdb->prefix}in8sync_log WHERE woo_object_id='{$_GET['view_in8_log_object_id']}' ORDER BY created_at DESC LIMIT 50");
		
		if (!empty($results)) {
			?>
            <h2>
                Sync logs for this item.
                <a href="<?= site_url('wp-admin/admin.php?page=in8sync#logs') ?>" style="float: right;">All sync
                    logs</a>
            </h2>
            <table id="in8LogFile" class="widefat fixed">
                <thead>
                <tr style="width: 80px">
                    <td>Date</td>
                    <td>Operation</td>
                    <td>Logs</td>
                </tr>
                </thead>
                <tbody>
				<?php foreach ($results as $line) { ?>
                    <tr>
                        <td><?= $line->created_at ?></td>
                        <td><?= $line->operation ?></td>
                        <td><?= $line->notes ?></td>
                    </tr>
				<?php } ?>
                </tbody>
            </table>
			<?php
		} else {
			echo 'Log is empty.';
		}
		exit;
	}
	add_action('admin_init', function(){
		if (!empty($_GET['view_in8_log_type']) && !empty($_GET['view_in8_log_object']) && !empty($_GET['view_in8_log_object_id'])) {
			view_IN8_file();
		}
    });
	
	
	function in8_is_plugin_active($plugin){
		if ( ! function_exists( 'is_plugin_active' ) )
			require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
		
		return is_plugin_active($plugin);
	}